import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * This is a white blood cell. This kind of cell has the job to catch 
 * BlackAsteroid and remove them from the blood.
 * 

 */
public class SpaceShip extends Actor
{
    private int score;
    public boolean deployShield;
    GreenfootImage img1 = new GreenfootImage("spaceShip.png");
    GreenfootImage img2 = new GreenfootImage("spaceShipv2.png");
    /**
     * http://www.clipartlord.com/category/space-clip-art/spaceship-clip-art/page/2/ 
     */
    public void act() 
    {
        checkKeyPress();
        checkCollision();
        lookForAsteroid();
        lookForPowerUp();
        score = 0;
        checkMouse();
        shoot();
        check();
    }

    /**
     * Check whether a keyboard key has been pressed and react if it has.
     */
    private void checkKeyPress()
    {
        if (Greenfoot.isKeyDown("w")) 
        {
            setLocation(getX(), getY()-4);
        }
        if (Greenfoot.isKeyDown("s")) 
        {
            setLocation(getX(), getY()+4);
        }
        if (Greenfoot.isKeyDown("a")) 
        {
            setLocation(getX()-4, getY());
        }
        if (Greenfoot.isKeyDown("d")) 
        {
            setLocation(getX()+4, getY());
        }
    }

    /**
     * the first time you use this, you have to click twice, after this only
     * one click is required
     */
    public void checkMouse()
    {
        if (Greenfoot.mouseClicked(null))
        {
            switchImage();
        }
    }

    public void switchImage()
    {
        if (getImage() == img1) 
        {
            setImage(img2);
        }
        else {
            setImage(img1);
        }
    }

    public void checkCollision()
    {
        if ( isTouching(BlackAsteroid.class) ) 
        {            
            Greenfoot.playSound("break.wav");
            removeTouching(BlackAsteroid.class);
            Space Space = (Space)getWorld();
            Space.addScore(20);
        }
    }

    public void lookForAsteroid()
    {
        if ( isTouching(Asteroid.class) ) 
        {
            Greenfoot.playSound("hit.wav");
            removeTouching(Asteroid.class);
            Space Space = (Space)getWorld();
            Space.addScore(-100);
        }
    }

    public void lookForPowerUp()
    {
        if ( isTouching(PowerUp.class) ) 

        {   BigShield bigshield = new BigShield();
            getWorld().addObject(bigshield, getX(), getY());
        }
        removeTouching(PowerUp.class);
        for (Object obj : getWorld().getObjects(BigShield.class))
        {
            BigShield bigshield = (BigShield) obj;
            bigshield.TimeShield();
        }
    }

    public void shoot()
    {
        if ("space".equals(Greenfoot.getKey()))
        {
            Bullet bullet = new Bullet();
            getWorld().addObject(bullet, getX(), getY());
        }
    }

    public void check()
    {
        if (deployShield = true)
        {
            protect();
        }
    }

    public void protect()
    {
        if (Greenfoot.isKeyDown("e")) 
        {
            PersonalSheild personalsheild = new PersonalSheild();
            getWorld().addObject(personalsheild, getX(), getY());
        }
    }
}
